function [ initialVariables, initialConstants ] = Initial_SpaceExToStateflow(initial, variables, opt_cfg)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------

    initialVariables = ''; %initial states of variables set in cfg file
    initialConstants = ''; %initial states of constants set in cfg file
    if opt_cfg
        Initial_Parse = regexp(initial, '(\w+)(\s)?==(\s)?(\d+)(\.\d+)?', 'match');
        
        % replace '==' (SpaceEx format) with '=' (required Stateflow format)
        Initial_Parse = strrep(Initial_Parse, '==', '=');
        
        %TODO handle nondeterministic condition
        for i = 1: length(Initial_Parse)
            matchVariable = false;
            Initial_Parse_temp = Initial_Parse{i};
            for j = 1: length(variables)
                if strcmp(regexp(Initial_Parse_temp, '(\w+)=', 'match'), strcat(variables{j}, '='))
                    initialVariables = strcat(initialVariables, Initial_Parse_temp, '; ');
                    matchVariable = true;
                    break;
                end
            end
            if (~ matchVariable)
                initialConstants = strcat(initialConstants, Initial_Parse_temp, '; ');
            end
        end
        initialConstants = strsplit(initialConstants,';');
    end
end