function [Variable, output, flow, OutputDescription] = Variable_SpaceExToStateflow(flow)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------

    %Flow = regexprep(regexprep(Flow,'''','_dot'),'&&',';\n');   
    % Create ODEs in SLSF format
    flow = regexprep(regexprep(flow,'''','_dot'),'&&',';\n'); 
    Variable_prime = regexp(flow, '[a-zA-Z_][a-zA-Z0-9_]*_dot', 'match');
    %Variable_prime = regexp(flow, '[a-z_]+_dot', 'match');
    % parse local variables
    Variable = regexprep(Variable_prime,'_dot',''); 
    OutputDescription = '';
    output = '';
    for i = 1: length(Variable)
        output{i} = strcat(Variable{i},'_out');
        OutputDescription = [char(OutputDescription),10,output{i},'=',Variable{i},';'];
    end
end