function [out] = guard_randgen_hybridautomaton(x_sys,i_loc,num_var, trans_count,guard_op, opt_dwelltime,...
            opt_constant_invariant, opt_symbolic_invariant, opt_imaginary, opt_zero, rand_cons_invariant, rand_syms_invariant,T)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------        
    % radnomly generate a guard condition for each transition
    guard = '';
    if opt_dwelltime == 1
        %guard = ['t >=',num2str(T(i)- guard_counter(i))];
        guard = ['t >=',num2str(T(i_loc)+(trans_count(i_loc)-1)*rand/100)];
        %guard_counter(i) = guard_counter(i) + 1;
        if opt_constant_invariant   
            if opt_imaginary 
                for i_var = 1: num_var
                    %guard = [guard,'&&','(',char(x_sys(i_var)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,i_var)*rand),4)),'&&',...
                                            %char(x_sys(i_var)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,i_var)*rand),4)),')']
                    guard = [guard,'&&',char(vpa(num2str(rand_cons_invariant(i_loc,i_var)*rand),4)),guard_op,...
                            char(x_sys(i_var)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,i_var)*rand),4))];

                end
            else
                for i_var = 1: num_var
                    %guard = [guard,'&&',char(x_sys(i_var)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,i_var)*(1+rand)),4))];
                    guard = [guard,'&&',char(x_sys(i_var)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,i_var)+(trans_count(i_loc)-1)*rand/100),4))];
                end
            end
        elseif opt_symbolic_invariant   
            i_var = randi([1, num_var]);
            guard_tmp = char(vpa(rand_syms_invariant(i_loc,i_var)*rand-(trans_count(i_loc)-1)*rand/100,4));
            if ~isempty(guard_tmp)
                if  strcmp(guard_tmp(1),'-')
                    guard_tmp = ['0',guard_tmp];
                end
            end
            %guard = [guard,'&&',char(x_sys(i_var)),guard_op,char(vpa(rand_syms_invariant(i_loc,i_var)*rand-(trans_count(i_loc)-1)*rand/100,4))];
            guard = [guard,'&&',char(x_sys(i_var)),guard_op,guard_tmp];
            % test one variable
            %for i_var = 1: num_var
                %guard = [guard,'&&',char(x_sys(i_var)),guard_op,char(vpa(rand_syms_invariant(i_loc,i_var)*(1+rand),4))];
             %   guard = [guard,'&&',char(x_sys(i_var)),geq_op,char(vpa(rand_syms_invariant(i_loc,i_var)+(trans_count(i_loc)-1)*rand/100,4))];
            %end
        end    
    else
        if opt_constant_invariant     
            if opt_imaginary
                guard = [char(vpa(num2str(rand_cons_invariant(i_loc,1)*rand),4)),guard_op,...
                            char(x_sys(1)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,1)*rand),4))];
                for i_var = 2: num_var
                    guard = [guard,'&&',char(vpa(num2str(rand_cons_invariant(i_loc,i_var)*rand),4)),guard_op,...
                            char(x_sys(i_var)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,i_var)*rand),4))];                                                        
                end
            elseif opt_zero == 1
                guard = [char(x_sys(1)),guard_op,num2str(rand_cons_invariant(i_loc,1))];
                for i_var = 2: num_var
                    guard = [guard,'&&',char(x_sys(i_var)),guard_op,num2str(rand_cons_invariant(i_loc,i_var))];
                end
            else  
                if num_var == 1
                    guard = [char(x_sys),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,1)),4))];
                else    
                    %guard = [char(x_sys(1)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,1)*(1+rand)),4))];
                    guard = [char(x_sys(1)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,1)+(trans_count(i_loc)-1)*rand/100),4))];
                    for i_var = 2: num_var
                        %guard = [guard,'&&',char(x_sys(i_var)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,i_var)+(trans_count(i_loc)-1)*rand/100),4))];
                        guard = [guard,'&&',char(x_sys(i_var)),guard_op,char(vpa(num2str(rand_cons_invariant(i_loc,i_var)-(trans_count(i_loc)-1)*rand/100),4))];
                    end
                end
            end
        elseif opt_symbolic_invariant   
            i_var = randi([1, num_var]);
            guard_tmp = char(vpa(rand_syms_invariant(i_loc,i_var)+(trans_count(i_loc)-1)*rand/100,4));
            if ~isempty(guard_tmp)
                if  strcmp(guard_tmp(1),'-')
                    guard_tmp = ['0',guard_tmp];
                end
            end
            guard = [char(x_sys(i_var)),guard_op,guard_tmp];
            %guard = [char(x_sys(1)),guard_op,char(vpa(rand_syms_invariant(i_loc,1)+(trans_count(i_loc)-1)*rand/100,4))];
            %for i_var = 2: num_var
             %   guard = [guard,'&&',char(x_sys(i_var)),geq_op,char(vpa(rand_syms_invariant(i_loc,i_var)+(trans_count(i_loc)-1)*rand/100,4))];
            %end
        end 
    end
    out = guard;
end    
    