function [out] = invariant_randgen_hybridautomaton(x_sys,i_loc,num_var,inv_op, opt_dwelltime,...
            opt_constant_invariant, opt_symbolic_invariant, opt_imaginary, opt_zero, rand_cons_invariant, rand_syms_invariant, T)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------        
% randomly generate invariant for each location. 
    invariant = '';
    if opt_dwelltime == 1
        invariant = ['t <=',num2str(T(i_loc))];
        if opt_constant_invariant
            
            if  opt_imaginary 
                for i_var = 1: num_var
                    invariant = [invariant,'&&',char(x_sys(i_var)),inv_op,num2str(rand_cons_invariant(i_loc,i_var)),'&&',...
                                                    char(x_sys(i_var)),inv_op,num2str(rand_cons_invariant(i_loc,i_var))];                          
                end
            else
                for i_var = 1: num_var
                    invariant = [invariant,'&&',char(x_sys(i_var)),inv_op,num2str(rand_cons_invariant(i_loc,i_var))];
                end
            end    
        elseif opt_symbolic_invariant  

            for i_var = 1: num_var
                invariant = [invariant,'&&',char(x_sys(i_var)),inv_op,char(rand_syms_invariant(i_loc,i_var))];
            end
        end
    else
        if opt_constant_invariant       
            if opt_imaginary 
                invariant = [num2str(rand_cons_invariant(i_loc,1)),inv_op, char(x_sys(1)),inv_op,num2str(rand_cons_invariant(i_loc,1))];
                if num_var > 1
                    for i_var = 2: num_var
                        invariant = [invariant,'&&',num2str(rand_cons_invariant(i_loc,i_var)),inv_op, char(x_sys(i_var)),...
                                                                                inv_op,num2str(rand_cons_invariant(i_loc,i_var))];                            
                    end
                end
            elseif opt_zero                            
                    invariant = [char(x_sys(1)),inv_op,num2str(rand_cons_invariant(i_loc,1))];
            else
                invariant = [char(x_sys(1)),inv_op,num2str(rand_cons_invariant(i_loc,1))];
                if num_var > 2
                    for i_var = 2: num_var
                        invariant = [invariant,'&&',char(x_sys(i_var)),inv_op,num2str(rand_cons_invariant(i_loc,i_var))];
                    end
                end
            end         
        elseif opt_symbolic_invariant   
            invariant = [char(x_sys(1)),inv_op,char(rand_syms_invariant(i_loc,1))];
            for i_var = 2: num_var
                invariant = [invariant,'&&',char(x_sys(i_var)),inv_op,char(rand_syms_invariant(i_loc,i_var))];
            end
        end  
    end
    % return invariant 
    out = invariant;
end