classdef EEqualityHandling < int32
%EEQUALITYHANDLING enumeration for equality handling
% This enum class holds all modes for handling equalities.
%
% ------------------------------------------------------------------------------
% author: Christian Schilling
% ------------------------------------------------------------------------------

    enumeration
        singleEq (0); % single equality (=)
        doubleEq (1); % double equality (==)
        interval (2); % interval (lhs - eps <= rhs && lhs + eps >= rhs)
    end
end